# -*- coding: utf-8 -*-
from qgis.PyQt.QtGui import *
from qgis.PyQt.QtWidgets import *
from qgis.PyQt.QtCore import Qt
from qgis.core import Qgis
from qgis.gui import QgsMapToolEmitPoint, QgsFileWidget, QgsMessageBar
from qgis.utils import iface


class fenetre(QDialog):
	def __init__(self, parent=None):
		flags= Qt.WindowTitleHint | Qt.WindowMaximizeButtonHint | Qt.WindowCloseButtonHint
		# Pour que la fenêtre reste au-dessus des autres, ajouter:  | Qt.WindowStaysOnTopHint
		QDialog.__init__(self, parent, flags) # parent=None permet de retrouver la fenetre dans la barre des taches
		win = iface.mainWindow()
		
		self.setWindowTitle("Mes outils")
		# Il faut positionner le dialog MANUELLEMENT, sinon Qt va le repositionner automatiquement à chaque hide -> show :
		self.setGeometry(win.geometry().x()+50, win.geometry().y()+20, 500, 300)
		
		grille = QGridLayout(self)
		grille.setContentsMargins(10, 10, 10, 10)  #hLayout1= QHBoxLayout()    grille.addLayout(hLayout1, 0, 0)
		
		li = 0
		etiTitre = QLabel("<center><b>Mon titre centré</b></center>")
		etiTitre.setSizePolicy( QSizePolicy.Expanding, QSizePolicy.Fixed )
		grille.addWidget(etiTitre, li, 0, 1, 2)
		
		li += 1
		eti1 = QLabel("<b>Pour choisir un fichier</b>")
		eti1.setSizePolicy( QSizePolicy.Fixed, QSizePolicy.Fixed )
		grille.addWidget(eti1, li, 0, 1, 1)
		self.choixFic= QgsFileWidget()
		#self.choixFic.setFilePath("Choisir le fichier à afficher")
		#self.choixFic.setFilter('*.gpkg')
		self.choixFic.setStorageMode(QgsFileWidget.GetFile)
		self.choixFic.fileChanged.connect( self.lireFic )
		self.choixFic.setSizePolicy( QSizePolicy.Expanding, QSizePolicy.Fixed )
		grille.addWidget(self.choixFic, li, 1, 1, 1)
		
		li += 1
		etiTxt = QLabel("<b>Pour entrer du texte :</b>")
		grille.addWidget(etiTxt, li, 0, 1, 1)
		self.qTexte = QLineEdit()		#self.typeFic.setMinimumSize(50,28)
		#self.typeFic.setSizePolicy( QSizePolicy.Expanding, QSizePolicy.Fixed )
		grille.addWidget(self.qTexte, li, 1, 1, 1)
		
		li += 1
		bCoord = QPushButton("Trouver les coordonnées (cliquer sur la carte)")
		bCoord.clicked.connect(self.trouverCoord)
		bCoord.setToolTip("Activer l'outil de pointage dans la carte")
		grille.addWidget(bCoord, li, 1, 1, 2)
		
		li += 1
		self.lCoord = QLineEdit()
		self.lCoord.setSizePolicy( QSizePolicy.Expanding, QSizePolicy.Fixed )
		grille.addWidget(self.lCoord, li, 0, 1, 2)
		
		li += 1
		self.messageBar = QgsMessageBar(self) # Barre de message dans cette fenetre
		self.messageBar.setSizePolicy( QSizePolicy.Expanding, QSizePolicy.Fixed )
		grille.addWidget(self.messageBar, li, 0, 1, 3)
		
		## L'outil pour trouver des coordonnées en cliquant dans la carte :
		self.pointTool = QgsMapToolEmitPoint(iface.mapCanvas())
		self.pointTool.canvasClicked.connect(self.voirCoord)



	def lireFic(self, fic):
		self.messageBar.clearWidgets()
		self.messageBar.pushMessage("Vous avez choisi : ", fic, Qgis.Success, 10 )



	def trouverCoord(self):
		self.hide()
		iface.mapCanvas().setMapTool(self.pointTool)


	def voirCoord(self, point): ## Afficher les coordonnées du point cliqué ci-dessus
		coords = "Coordonnées du clic : {:.1f}, {:.1f}".format(point.x(), point.y())
		self.show()
		self.lCoord.setText( coords )


